import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.Types;

import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;
import quadbase.reportdesigner.util.SimpleQueryFileInfo;
import quadbase.reportdesigner.util.SimpleQueryInParam;

public class SingleValueParameter extends Applet {
	static final long serialVersionUID = 1;

	public static void main(java.lang.String[] args) {

		try {

			SingleValueParameter doReport = new SingleValueParameter();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", doReport.doParameterizedReport(frame));
			frame.setSize(900, 800);
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);

		} catch (Exception ex) {

			ex.printStackTrace();

		}

	}

	@Override
	public void init() {

		setLayout(new BorderLayout());
		add("Center", doParameterizedReport(this));

	}

	Component doParameterizedReport(Object parent) {
		QbReport.setEspressManagerUsed(false);
		//		Begin Code : Adding Parameter Info
		//		SimpleQueryInParam(name of Parameter, String to be displayed, MapToColumn?, tableName, 
		//		ColumnName, SQL Type, DefaultValue, value)
		SimpleQueryInParam inParam = new SimpleQueryInParam(
				"param", "Please select", true, "Categories",
				"CategoryName", Types.VARCHAR, "Arm Chairs", null);
		SimpleQueryInParam[] paramSet = { inParam };

		SimpleQueryFileInfo reportInfo = new SimpleQueryFileInfo(
				"jdbc:hsqldb:woodview",
				"org.hsqldb.jdbcDriver",
				"sa", "",
				"select Categories.CategoryName, Products.ProductName, " +
						"	Products.UnitPrice, Products.UnitsInStock " +
						"from Categories, Products " +
						"where Categories.CategoryID=Products.CategoryID " +
						"and Categories.CategoryName=:param " +
						"order by Categories.CategoryName, Products.ProductName;");
		reportInfo.setInParam(paramSet);
		//		End Code : Adding Parameter Info

		//		Begin Code : Setting up Column Mapping
		ColInfo colInfo[] = new ColInfo[4];
		for (int i = 0; i < colInfo.length; i++) {
			colInfo[i] = new ColInfo(i);
		}
		colInfo[0].setPrimaryKey(true);
		colInfo[1].setName("Product Name");
		colInfo[2].setName("Price");
		colInfo[3].setName("Units In Stock");
		//		End Code : Setting up Column Mapping

		QbReport report = new QbReport(parent,
				QbReport.MASTERDETAILS,
				reportInfo,
				colInfo,
				"SingleValueParameter.rpt");

		return (new Viewer().getComponent(report));

	}

}
